



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Tomcat 内存与优化篇</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Tomcat 内存与优化篇</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 01:19:49 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>Tomcat 内存与优化<br />一、Tomcat 运行环境介绍<br />	1.Tomcat 本身无法直接在计算机上运行，需要依赖硬件基础上的操作系统和Java虚拟机；<br />	2.Java 程序启动时JVM都会分配一个初始内存和最大内存给这个应用；<br />	3.当应用程序用到最大内存的时刻，就会触发JVM做垃圾回收(GC)动作，释放被占用的内存；<br />	4.因此想要调整Java程序启动时的初始内存和最大内存，需要向JVM申请；<br />	5.如果初始内存大小设置过小，且此时初始化的应用对象过多，虚拟机就必须重复的加载内存来满足使用；<br />	6.基于以上原因，最好把初始内存大小(Xms)和最大内存(Xmx)设置成一样；<br />	7.JVM上所有的对象都在"""堆区(heap)"""上分配内存(也有在"栈"上分配内存的)<br />	8.堆区的大小是可以动态扩展的，但"""堆"""的大小受限于系统使用的物理内存，当应用程序需要的内存超出"堆"的最大值时，JVM虚拟机就会抛出内存溢出异常，并且导致应用程序奔溃；<br />	9.基于以上原因，建议&ldquo;堆&rdquo;的大小设置成物理内存的80%</p>
<p>二、Tomcat 内存设置(for Linux)<br />	1.&lt;CATALINA_HOME&gt;/bin/catalina.sh    #路径以及修改内存的文件<br />	2.JAVA_OPTS="-Xms256m -Xmx512m -Xss1024K -XX:PermSize=256m -XX:MaxPermSize=512m"  #内存参数以及值<br />	3.-Xms：初始内存大小<br />	4.-Xmx：最大内存<br />	5.-Xss：每个线程所消耗的内存大小(如-Xss15120是指每增加一个线程就会消耗15M内存)，最好设置成128K，默认值为512K<br />	6.-XX:PermSize：设定内存的永久保存区初始大小，默认为64M(永久是指方法区、永久代，还有年轻代、老年代)<br />	7.-XX:MaxPermSize：设定内存永久保存区最大大小，默认为64M<br />	8.其他参数：<br />		a)	-XX:SurvivorRatio=2：    #生还者池的大小，默认是2，如果垃圾回收变成了瓶颈，可以尝试定制生还者池设置<br />		b)	-XX:NewSize：			 #新生成的池的初始大小，默认为2M<br />		c)	-XX:MaxNewSize：		 #新生成的池的最大大小，默认为32M<br />		d)	+XX:AggressiveHeap       #该参数会使得Xms没有意义，这个参数让参数JVM忽略Xmx参数，疯狂的吃掉一个G的物理内存，再疯狂的吃掉一个G的swap<br />		e)	-verbose:gc				 #实现垃圾收集信息					<br />		f)	-Xloggc:gc.log			 #指定来及收集日志文件<br />		g)	-Xmn:					 #年轻代的堆区大小，一般设置成Xmx的3、4分之一<br />		h)	-XX:+UseParNewGC		 #缩短minor收集时间(minor GC是指在年轻代触发的GC垃圾回收动作)<br />		I)	-XX:+UseConcMarkSweepGC  #缩短major收集的时间(major收集是指在年老代触发Full GC垃圾回收动作)，此选项在heap size(堆区大小)比较大而且major收集时间较长的情况下使用更合适<br />		j)	-XX:userParNewGC         #可用来并行收集(多CPU)<br />		k)	-XX:ParallerGCThreads    #可用来增加并行度(多CPU)<br />		l)	-XX:UseParallerGC        #设置后可以使用并行清理收集器(多CPU)<br />		m)	如果JVM的堆大小大于 1G，则应该使用以下配置：<br />		-XX:newSize=640m -XX:MaxNewSize=640m -XX:SurvivorRatio=16<br />		或者将堆的总大小的50%到60%分配给新生成的池，调大新对象区，减少Full GC次数。<br />	9.注意：<br />		a)	虚拟机的"堆区大小"决定了虚拟机花费在收集垃圾上的时间和频率；<br />		b)	如果"堆的大小"很大，那么执行Full GC垃圾回收就会很慢，但是频率降低了；<br />		c)	如果把"堆的大小"调小，执行Full GC垃圾收回就会很快，但是会更加频繁；<br />		d)	因此建议把"堆区大小"设置物理内存的80%左右<br />		e)	建议把内存的最高值和最低值的差值缩小。不然会浪费很多内存；<br />		f)	最低值加大，那么最高值可以随便设置；<br />		g)	但是要根据实际的物理内存来设置，且大于物理内存，tomcat就无法启动，可能会导致内存被系统收回，终止进程</p>
<p>三、Tomcat 内存溢出以及调整<br />	1. java.lang.OutOfMemoryError: Java heap space ----JVM Heap（堆）溢出<br />		　　a)	释义：<br />			　　　　1.JVM在启动的时刻会自动设置JVM heap的值，其初始空间(即-Xms)是物理内存的1/64，最大空间(-Xmx)不可能超过物理内存；<br />			　　　　2.可以利用JVM提供的 -Xmn -Xms -Xmx等选项进行设置；<br />			　　　　3.heap的大小是年轻代(Young Generation)和年老代(Tenured Generaion)之和；<br />			　　　　4.在JVM中如果98%的时间用于GC，且可用的heap size不足2%的时刻将抛出此异常信息；</p>
<p>　　b)	解决：<br />			　　　　1.手动设置MaxPermSize的大小<br />			　　　　2.JAVA_OPTS="-server -Xms256m -Xmx512m -XX:PermSize=64M -XX:MaxPermSize=128m"</p>
<p>2. java.lang.OutOfMemoryError: PermGen space  ---- PermGen space溢出<br />		　　a)	释义：<br />			　　　　1.PermGen Space全程是Permanent Generation space，是指内存的永久保存区域；<br />			　　　　2.这里内存溢出的原因是因为这块内存主要是被JVM存放class和meta信息的，class在被load的时刻被放入PermGen Space区域；<br />			　　　　3.PermGen Space区域与存放instance的heap区域不同，GC不会在主程序运行期间对PermGen Space进行清理；<br />			　　　　4.基于以上原因，如果你的APP会载入很多class的话，就很可能出现PermGen Space溢出；</p>
<p>　　b)	解决：<br />			　　　　1.手动设置MaxPermSize大小</p>
<p>3.java.lang.StackOverflowError   ---- 栈溢出<br />		　　a)	释义：<br />			　　　　1.JVM采用的是栈式虚拟机，函数的调用过程都体现在堆栈和退栈上；<br />			　　　　2.调用构造函数的"层"太多了，以至于把栈区溢出了；</p>
<p>b)	解决：<br />			　　1.修改程序</p>
<p>4.ava.lang.OutOfMemoryError: GC overhead limit exceeded</p>
<p>　　<em>a)	这里的意思是指JVM溢出</em></p>
<p><em>		　　b)	增加参数，-XX:-UseGCOverheadLimit，关闭这个特性，同时增加heap大小，-Xmx1024m</em></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/jqde3ox9.html">C&num;-WebForm-点击网页中的按钮后跳转到其他页面是怎么实现的&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdjjyxq.html">iOS多线程之5&period;GCD的基本使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ogeppq.html">jQuery整体架构源码解析（转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8er4dkq.html">基于PHP实现阿里云开放存储服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j5lml8.html">android&period;widget&period;RadioButton 单选按钮（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p0gm7q.html">《信息安全系统设计基础》实验五 简单嵌入式WEB服务器实验</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn51rz8.html">bzoj1355&colon; &lbrack;Baltic2009&rsqb;Radio Transmission</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd63mjq.html">php正确解码javascript中通过escape编码后的字符</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdexxnx9.html">selenium文件上传的实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde1g2v9.html">30、ADO&period;NET、事务、DataSet</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgd1xe8.html">Windows的自带控件（比如TButton）大多数消息都由它自己处理，Delphi覆盖了那么多WM&lowbar;函数优先级较低，一般用不上</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg1dvm8.html">HashMap 构造函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y7y5n8.html">开源 &period;net license tool&comma; EasyLicense &excl;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mldxj8.html">Linux 文件操作命令-Linux基础环境命令学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zop1evq.html">HashSet源码分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7oov6j8.html">DWR第三篇之逆向Ajax升级</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj4r0z9.html">045、安装Docker Machine （2019-03-08 周五）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5mk1rq.html">跟踪分析Linux内核的启动过程--实验报告  分析   及知识重点</a>
		</li>
						<li><a href="https://www.batexi.com/a/90272jjq.html">AndroidStudio编译error&colon;app&colon;validateReleaseSigning&amp;&num;39&semi;Keystore file not found for signing config &amp;&num;39&semi;release</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk1w6d8.html">004 &commat;PathVariable映射URL绑定的占位符</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9j05e24q.html">在cygwin下编译c语言</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1z1pv49.html">基于JQUERY写的 LISTBOX 选择器</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1pylx8.html">JVM的内存区域划分划分及作用</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wp2oxq.html">C&sol;C&plus;&plus;中的隐式类型转换</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmo5l09.html">C&plus;&plus;读取一串不知个数的数字</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okm3el9.html">a标签加绝对定位在图片上面，a的链接和块状属性block失效&comma;而且是所有IE版本都失效的</a>
			</li>
						<li><a href="https://www.batexi.com/a/95x2z4e8.html">MooTools  异步请求验证</a>
			</li>
						<li><a href="https://www.batexi.com/a/qde7xwj9.html">DataTables选择行并删除（删除单行）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1zx3m9.html">从ASM迁移到ARM（1）：平台支持的迁移服务</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjlvv79.html">IE查看控件时常</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
